package org.nakedobjects.nos.client.dnd;

import org.nakedobjects.noa.NakedObjectRuntimeException;


/** @deprecated */
public class SimpleFocusManager implements FocusManager {
    private View focus;

    public View firstView() {
        return null;
    }

    public void focusFirstChildView() {
        View[] views = focus.getSubviews();
        for (int j = 0; j < views.length; j++) {
            if (views[j].canFocus()) {
                setFocus(views[j]);
                return;
            }
        }

        // no other focusable view; stick with the view we've got
        return;
    }

    public void focusNextView() {
        View parent = focus.getParent();
        if (parent == null) {
            return;
        }

        View[] views = parent.getSubviews();
        for (int i = 0; i < views.length; i++) {
            if (views[i] == focus) {
                for (int j = i + 1; j < views.length; j++) {
                    if (views[j].canFocus()) {
                        setFocus(views[j]);
                        return;
                    }
                }
                for (int j = 0; j < i; j++) {
                    if (views[j].canFocus()) {
                        setFocus(views[j]);
                        return;
                    }
                }
                // no other focusable view; stick with the view we've got
                return;
            }
        }

        throw new NakedObjectRuntimeException();
    }

    public void focusParentView() {
        View parent = focus.getParent();
        if (parent == null) {
            return;
        }

        setFocus(parent);
    }

    public void focusPreviousView() {
        View parent = focus.getParent();
        if (parent == null) {
            return;
        }

        View[] views = parent.getSubviews();

        for (int i = 0; i < views.length; i++) {
            if (views[i] == focus) {
                for (int j = i - 1; j >= 0; j--) {
                    if (views[j].canFocus()) {
                        setFocus(views[j]);
                        return;
                    }
                }
                for (int j = views.length - 1; j > i; j--) {
                    if (views[j].canFocus()) {
                        setFocus(views[j]);
                        return;
                    }
                }
                // no other focusable view; stick with the view we've got
                return;
            }
        }

        throw new NakedObjectRuntimeException("Can't move to previous peer from " + focus);
    }

    public View getFocus() {
        return focus;
    }

    public View initialView() {
        return null;
    }

    public View lastView() {
        return null;
    }

    public void setFocus(final View view) {
        if (view != null && view.canFocus()) {
            if ((focus != null) && (focus != view)) {
                focus.focusLost();
                focus.markDamaged();
            }

            focus = view;
            focus.focusReceived();

            view.markDamaged();
        }
    }

    public void focusLastChildView() {}

    public void focusInitialChildView() {}

}
// Copyright (c) Naked Objects Group Ltd.
