package org.nakedobjects.nos.client.dnd.basic;

import org.nakedobjects.noa.adapter.value.PasswordValue;
import org.nakedobjects.nos.client.dnd.Content;
import org.nakedobjects.nos.client.dnd.View;
import org.nakedobjects.nos.client.dnd.ViewAxis;
import org.nakedobjects.nos.client.dnd.builder.AbstractFieldSpecification;
import org.nakedobjects.nos.client.dnd.view.field.PasswordField;


public class PasswordFieldSpecification extends AbstractFieldSpecification {
    public boolean canDisplay(final Content content) {
        return content.isValue() && content.getNaked() instanceof PasswordValue;
    }

    public View createView(final Content content, final ViewAxis axis) {
        return new PasswordField(content, this, axis);
    }

    public String getName() {
        return "Password Field";
    }
    
    public boolean isAligned() {
        return true;
    }
}
// Copyright (c) Naked Objects Group Ltd.
