package org.nakedobjects.nos.client.dnd.basic;

import org.nakedobjects.nof.core.context.NakedObjectsContext;
import org.nakedobjects.nos.client.dnd.Canvas;
import org.nakedobjects.nos.client.dnd.Toolkit;
import org.nakedobjects.nos.client.dnd.View;
import org.nakedobjects.nos.client.dnd.drawing.Shape;
import org.nakedobjects.nos.client.dnd.drawing.Size;
import org.nakedobjects.nos.client.dnd.util.Properties;


public class TextFieldResizeBorder extends ResizeBorder {
    public static final int BORDER_WIDTH = NakedObjectsContext.getConfiguration().getInteger(Properties.PROPERTY_BASE + "field-resize-border", 5);

    public TextFieldResizeBorder(final View view) {
        super(view, RIGHT + DOWN, 1, 1);
    }

    protected void drawResizeBorder(final Canvas canvas, final Size size) {
        if (resizing) {
            Shape shape = new Shape(0, 0);
            int resizeMarkerSize = 10;
            shape.extendsLine(resizeMarkerSize, 0);
            shape.extendsLine(0, resizeMarkerSize);
            shape.extendsLine(-resizeMarkerSize, -resizeMarkerSize);
            canvas.drawSolidShape(shape, size.getWidth() - resizeMarkerSize, size.getHeight(), Toolkit.getColor("secondary1"));
            canvas.drawRectangle(0, 0, size.getWidth(), size.getHeight(), Toolkit.getColor("secondary1"));
        }
    }
}
// Copyright (c) Naked Objects Group Ltd.
