package org.nakedobjects.nos.client.dnd.lookup;

import org.nakedobjects.nof.core.util.UnexpectedCallException;
import org.nakedobjects.nos.client.dnd.Content;
import org.nakedobjects.nos.client.dnd.SubviewSpec;
import org.nakedobjects.nos.client.dnd.Toolkit;
import org.nakedobjects.nos.client.dnd.View;
import org.nakedobjects.nos.client.dnd.ViewAxis;
import org.nakedobjects.nos.client.dnd.border.DisposeOverlay;
import org.nakedobjects.nos.client.dnd.border.PanelBorder;
import org.nakedobjects.nos.client.dnd.border.ScrollBorder;
import org.nakedobjects.nos.client.dnd.builder.AbstractCompositeViewSpecification;
import org.nakedobjects.nos.client.dnd.builder.StackLayout;
import org.nakedobjects.nos.client.dnd.drawing.Text;
import org.nakedobjects.nos.client.dnd.view.graphic.IconGraphic;
import org.nakedobjects.nos.client.dnd.view.simple.Icon;
import org.nakedobjects.nos.client.dnd.view.text.ObjectTitleText;


class DropDownObjectOverlaySpecification extends AbstractCompositeViewSpecification implements SubviewSpec {
    public DropDownObjectOverlaySpecification() {
        builder = new StackLayout(new DropDownListBuilder(this), true);
    }

    public boolean canDisplay(final Content content) {
        throw new UnexpectedCallException();
    }

    // TODO make this class abstract and create subclass (DropDownObjectObjectOverlaySepecification) with this method
    public View createSubview(final Content content, final ViewAxis lookupAxis) {
        Icon icon = new Icon(content, this, lookupAxis);
        Text style = Toolkit.getText("normal");
        icon.setTitle(new ObjectTitleText(icon, style));
        icon.setSelectedIcon(new IconGraphic(icon, style));
        return new DropDownSelection(icon);
    }

    public View createView(final Content content, final ViewAxis axis) {
        View list = super.createView(content, axis);
        list = new DropDownFocusBorder(list);
        return new DisposeOverlay(new PanelBorder(1, new ScrollBorder(list)));
    }

    public String getName() {
        return "Object Drop Down Overlay";
    }
}

// Copyright (c) Naked Objects Group Ltd.
