package org.nakedobjects.nos.client.dnd.view.field;

import org.nakedobjects.noa.adapter.NakedValue;
import org.nakedobjects.nof.core.context.NakedObjectsContext;
import org.nakedobjects.nos.client.dnd.ValueContent;
import org.nakedobjects.nos.client.dnd.View;
import org.nakedobjects.nos.client.dnd.action.AbstractUserAction;


public abstract class AbstractValueOption extends AbstractUserAction {
    AbstractValueOption(String name) {
        super(name);
    }

    protected NakedValue getValue(final View view) {
        ValueContent vc = (ValueContent) view.getContent();
        NakedValue value = vc.getObject();
        return value;
    }

    protected void updateParent(final View view) {
        NakedObjectsContext.getObjectPersistor().saveChanges();
        view.markDamaged();
        view.getParent().invalidateContent();
    }

    protected boolean isEmpty(final View view) {
        ValueContent field = (ValueContent) view.getContent();
        return field.isEmpty();
    }
}
// Copyright (c) Naked Objects Group Ltd.
