package org.nakedobjects.nos.client.dnd.view.form;

import org.nakedobjects.nos.client.dnd.Content;
import org.nakedobjects.nos.client.dnd.ObjectContent;
import org.nakedobjects.nos.client.dnd.SubviewSpec;
import org.nakedobjects.nos.client.dnd.Toolkit;
import org.nakedobjects.nos.client.dnd.View;
import org.nakedobjects.nos.client.dnd.ViewAxis;
import org.nakedobjects.nos.client.dnd.ViewSpecification;
import org.nakedobjects.nos.client.dnd.builder.AbstractCompositeViewSpecification;
import org.nakedobjects.nos.client.dnd.builder.CollectionElementBuilder;
import org.nakedobjects.nos.client.dnd.builder.StackLayout;


public class InternalListSpecification extends AbstractCompositeViewSpecification implements SubviewSpec {

    public InternalListSpecification() {
        builder = new StackLayout(new CollectionElementBuilder(this));
    }

    public View createView(Content content, ViewAxis axis) {
        View view = super.createView(content, axis);
        return new InternalCollectionBorder(view);
    }
    
    // TODO the rest of this is the same as ListSpecification
    public View createSubview(final Content content, final ViewAxis axis) {
        ViewSpecification specification = Toolkit.getViewFactory().getIconizedSubViewSpecification((ObjectContent) content);
        return specification.createView(content, axis);
    }

    public String getName() {
        return "Standard List";
    }

    public boolean canDisplay(final Content content) {
        return content.isCollection();
    }
}
// Copyright (c) Naked Objects Group Ltd.
