package org.nakedobjects.nos.client.dnd.view.simple;

import org.nakedobjects.nof.core.util.UnexpectedCallException;
import org.nakedobjects.nos.client.dnd.Content;
import org.nakedobjects.nos.client.dnd.View;
import org.nakedobjects.nos.client.dnd.ViewAxis;
import org.nakedobjects.nos.client.dnd.ViewSpecification;


class NonBuildingSpecification implements ViewSpecification {
    private String name;

    public NonBuildingSpecification(final View view) {
        String name = view.getClass().getName();
        this.name = name.substring(name.lastIndexOf('.') + 1);
    }

    public View createView(final Content content, final ViewAxis axis) {
        throw new UnexpectedCallException();
    }

    public String getName() {
        return name;
    }

    public boolean isAligned() {
        return false;
    }

    public boolean isOpen() {
        return true;
    }

    public boolean isReplaceable() {
        return false;
    }

    public boolean isSubView() {
        return false;
    }

    public boolean canDisplay(final Content content) {
        return false;
    }

}
// Copyright (c) Naked Objects Group Ltd.
